/* MAC 440/5759 - Sistemas de Objetos Distribudos  */
/* IME-USP - 1o.sem/2002 - Prof. Fabio Kon          */
/*                                                  */
/* Projeto Final: Siscoma                           */
/*                                                  */
/* Emerson Luiz Navarro  - emr@linux.ime.usp.br     */
/* Leo Kazuhiro Ueda     -  lku@ime.usp.br          */
/* Pratip Roy Chowdhury  - roy@linux.ime.usp.br     */
/* Ricardo Hideo Sahara  - hideo@linux.ime.usp.br   */
/*                                                  */


/* CaixaDeCoisas.java */

import java.util.*;

public class CaixaDeCoisas {

  private Map Coisas;

  private CDCDestrutor Destrutor;

  private static final int TDV = 12;


  public CaixaDeCoisas ( ) {

    this.Coisas = new Hashtable( );
    Destrutor = FazNada.instancia();

  }

  public CaixaDeCoisas (CDCDestrutor dest ) {

    this.Coisas = new Hashtable( );
    Destrutor = dest;

  }

  
  public void guarde (Object id, Object coisa) {

    Coisas.put(id, new Coisa(id, coisa, TDV));
    
  }
  
  public void remova (Object id) {

    Object o = Coisas.remove(id);
    if (o == null) return;
    Destrutor.acao(o);

  }

  public Object pega(Object id) {
    Coisa c = (Coisa)Coisas.get(id);
    if (c == null) return null;
    return c.coisa();
  }

  public boolean recebi (Object id) {

    Coisa c = (Coisa)Coisas.get(id);
    if (c == null) return false;

    c.tdv(TDV);

    return false;
    
  }

  public void decTdv ( ) {
    Collection rm = new ArrayList();

    Iterator it = Coisas.values().iterator();
    while (it.hasNext()) {
      Coisa m = (Coisa) it.next();
      m.decTdv( );
      if (m.tdv( ) <= 0) {
	rm.add(m);
      }
    }

    it = rm.iterator();
    while (it.hasNext()) {
      Coisa m = (Coisa) it.next();
      System.out.println("CaixaDeMensagens: removendo " + m.id( ));
      Coisas.remove(m);
      Destrutor.acao(m);
    }
    
  }
  
}


class Coisa {

  private Object coisa;
  private Object id;
  
  private int tdv;


  public Coisa (Object id, Object coisa, int tdv) {

    this.id = id;
    this.coisa = coisa;
    this.tdv = tdv;

  }

  public Object coisa ( ) { return coisa; }
  public Object id ( ) { return id; }

  public int tdv ( ) { return tdv; }  
  public void decTdv ( ) { tdv--; }
  public void incTdv ( ) { tdv++; }
  public void tdv ( int t ) { tdv = t; }


}

class FazNada implements CDCDestrutor {
  private static FazNada Instancia;

  private FazNada() {
    if (Instancia != null)
      throw new Error("S pode haver um! Use 'CDCDestrutor.instancia()'.");
  }

  public void acao(Object coisa) {}

  public static FazNada instancia() {
    if (Instancia == null)
      Instancia = new FazNada();
    return Instancia;
  }
}
