/* MAC 440/5759 - Sistemas de Objetos Distribudos  */
/* IME-USP - 1o.sem/2002 - Prof. Fabio Kon          */
/*                                                  */
/* Projeto Final: Siscoma                           */
/*                                                  */
/* Emerson Luiz Navarro  - emr@linux.ime.usp.br     */
/* Leo Kazuhiro Ueda     -  lku@ime.usp.br          */
/* Pratip Roy Chowdhury  - roy@linux.ime.usp.br     */
/* Ricardo Hideo Sahara  - hideo@linux.ime.usp.br   */
/*                                                  */


/* IGui.java */

import java.util.Collection;
import siscoma.orb.Servente;

/**
 * Mtodos que uma interface grfica (ou talvez qualquer programa
 * de interao com o usurio) precisam implementar.
 * Eles so chamados por um <code>ServenteImpl</code> de acordo
 * com eventos que ocorrem no sistema <i>Siscoma</i>.
 */
public interface IGui {
  
  /**
   * Fornece as respostas de uma busca.
   *
   * @param c coleo de <code>ArquivoRemoto</code>
   */
  public abstract void resposta_da_busca(Collection c);

  /**
   * Avisa que um novo amigo se conectou.
   *
   * @param s o amigo
   */  
  public abstract void novo_amigo(String nome, Servente s);
  /**
   * Avisa que um amigo caiu.
   *
   * @param s o amigo
   */  
  public abstract void caiu_amigo(String nome, Servente s);
  /**
   * Avisa que um amigo se desconectou.
   *
   * @param s o amigo
   */  
  public abstract void desconectou(String nome, Servente s);
  /**
   * Avisa que algum pegou um pedao de um arquivo.
   *
   * @param arq o nome do arquivo
   * @param pos a posio de incio do pedao em bytes
   * @param numBytes tamanho do pedao em bytes
   */  
  public abstract void enviou(String arq, int pos, int numBytes);
 
}
