/* MAC 440/5759 - Sistemas de Objetos Distribudos  */
/* IME-USP - 1o.sem/2002 - Prof. Fabio Kon          */
/*                                                  */
/* Projeto Final: Siscoma                           */
/*                                                  */
/* Emerson Luiz Navarro  - emr@linux.ime.usp.br     */
/* Leo Kazuhiro Ueda     -  lku@ime.usp.br          */
/* Pratip Roy Chowdhury  - roy@linux.ime.usp.br     */
/* Ricardo Hideo Sahara  - hideo@linux.ime.usp.br   */
/*                                                  */


/* JBusca.java */

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.*;

public class JBusca extends JPanel implements ActionListener {

  private JTextField tfPadrao;
  private JButton btBuscar;
  private JButton btFechar;
  private JTabbedPane tpBuscas;
  private Map buscas; 
  private Map buscasIds;
  private JSiscoma jsiscoma;
  
  public JBusca (JSiscoma jsiscoma) {

    setLayout(new BorderLayout( ));
    setPreferredSize(new Dimension(600, 600));
    setVisible(true);        
    this.jsiscoma = jsiscoma;
    this.tfPadrao = new JTextField(30);
    this.btBuscar = new JButton("Buscar");    
    btBuscar.addActionListener(this);
    JPanel p1 = new JPanel(new FlowLayout(FlowLayout.CENTER, 20, 5));        
    p1.setBorder(BorderFactory.createTitledBorder
		 ("Entre com o padro para a busca"));
    p1.add(tfPadrao);
    p1.add(btBuscar);
    
    /* Criando uma tabela com os arquivos achados. */             
    JPanel p2 = new JPanel(new BorderLayout( ));
    p2.setBorder(BorderFactory.createTitledBorder("Resultado da(s) busca(s)"));    
    this.tpBuscas = new JTabbedPane( );
    p2.add("Center", tpBuscas);    
    JPanel p3 = new JPanel(new FlowLayout(FlowLayout.CENTER, 20, 5));    
    btFechar = new JButton("Fechar");
    btFechar.addActionListener(this);
    p3.add(btFechar);
    p2.add("South", p3);    
    add("North", p1);
    add("Center", p2);    
    this.buscas = new Hashtable( );
    this.buscasIds = new Hashtable( );
    
  }
  
  public void baixarArquivo (ArquivoRemoto ar) {

    jsiscoma.baixarArquivo(ar);
    
  }

  public void resultadoDaBusca (Collection c) {

    Iterator it = c.iterator( );    
    if (it.hasNext( )) {
      ArquivoRemoto ar = (ArquivoRemoto) it.next( );      
      JResultadoDaBusca jrb = (JResultadoDaBusca) buscas.get(ar.id( ));
      jrb.adicionar(c);    
    } 
  } 

  public void actionPerformed (ActionEvent e) {
    
    Object obj = e.getSource( );
    if (obj instanceof JButton) {
      JButton b = (JButton) obj;
      if (b == btBuscar) {
	String padrao = tfPadrao.getText( );
	if (padrao != null) {	  
	  String id = jsiscoma.buscarArquivo(padrao);
	  JResultadoDaBusca jrb = new JResultadoDaBusca(this, id); 	
	  tpBuscas.addTab(padrao, jrb);
	  buscas.put(id, jrb);
	  buscasIds.put(id, padrao);
	}	
      }
      else if (b == btFechar) {	
	JResultadoDaBusca jrb = (JResultadoDaBusca)tpBuscas.getSelectedComponent( );
	if (jrb != null) {	  
	  tpBuscas.remove(jrb);	  
	  buscas.remove(jrb.id( ));	  	  
	  buscasIds.remove(jrb.id( ));
	}
      }
    }
    
  }    

}






