/* MAC 440/5759 - Sistemas de Objetos Distribudos  */
/* IME-USP - 1o.sem/2002 - Prof. Fabio Kon          */
/*                                                  */
/* Projeto Final: Siscoma                           */
/*                                                  */
/* Emerson Luiz Navarro  - emr@linux.ime.usp.br     */
/* Leo Kazuhiro Ueda     -  lku@ime.usp.br          */
/* Pratip Roy Chowdhury  - roy@linux.ime.usp.br     */
/* Ricardo Hideo Sahara  - hideo@linux.ime.usp.br   */
/*                                                  */


/* JConfig.java */

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.*;
import java.io.File;

public class JConfig extends JPanel implements ActionListener {
  
  private JTextField tfDownDir;
  private JTextField tfUpDir;
  private JButton btDownDir;
  private JButton btUpDir;
  private JFrame jsiscoma;

  public JConfig (JSiscoma jsiscoma) {  

    setLayout(new GridLayout(7, 1));
    setPreferredSize(new Dimension(600, 600));
    setVisible(true);
    this.jsiscoma = jsiscoma;
    this.tfDownDir = new JTextField(30);
    this.btDownDir = new JButton("Escolher");
    btDownDir.addActionListener(this);
    this.tfUpDir = new JTextField(30);
    this.btUpDir = new JButton("Escolher");
    btUpDir.addActionListener(this);

    tfDownDir.setText(Siscoma.DIRGRAV);
    tfUpDir.setText(Siscoma.DIRCOMP);

    tfDownDir.setEditable(false);
    tfUpDir.setEditable(false);
    
    /* Panel do config do download */
    JPanel p1 = new JPanel(new FlowLayout(FlowLayout.CENTER, 20, 10));
    p1.setBorder(BorderFactory.createTitledBorder
		 ("Diretrio onde iro os arquivos descarregados"));
    p1.add(tfDownDir);
    p1.add(btDownDir);
	
    /* Panel do config do upload */
    JPanel p2 = new JPanel(new FlowLayout(FlowLayout.CENTER, 20,10));
    p2.setBorder(BorderFactory.createTitledBorder
		 ("Diretrio compartilhado na rede SiscomaNet"));
    p2.add(tfUpDir);
    p2.add(btUpDir);

	add("North", p1);
	add("North", p2);
  }

    public void actionPerformed (ActionEvent e) {

	Object obj = e.getSource( );
	if (obj instanceof JButton) {
	    JButton b = (JButton) obj;
	    if (b == btDownDir) {
		final JFileChooser fcDownDir = new JFileChooser();
		int returnVal = fcDownDir.showOpenDialog(JConfig.this);
		File fDownDir = fcDownDir.getCurrentDirectory();
		tfDownDir.setText(fDownDir.getPath());		
		Siscoma.DIRGRAV = fDownDir.getPath();
	    }
	    else if (b == btUpDir) {
		final JFileChooser fcUpDir = new JFileChooser();
		int returnVal = fcUpDir.showOpenDialog(JConfig.this);
		File fUpDir = fcUpDir.getCurrentDirectory();
		tfUpDir.setText(fUpDir.getPath());
		Siscoma.DIRCOMP = fUpDir.getPath();
	    }
	}
    }


}




