/* MAC 440/5759 - Sistemas de Objetos Distribudos  */
/* IME-USP - 1o.sem/2002 - Prof. Fabio Kon          */
/*                                                  */
/* Projeto Final: Siscoma                           */
/*                                                  */
/* Emerson Luiz Navarro  - emr@linux.ime.usp.br     */
/* Leo Kazuhiro Ueda     -  lku@ime.usp.br          */
/* Pratip Roy Chowdhury  - roy@linux.ime.usp.br     */
/* Ricardo Hideo Sahara  - hideo@linux.ime.usp.br   */
/*                                                  */


/* JDownload.java */

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.table.*;


public class JDownload extends JPanel implements ActionListener {

  private Vector ativos;

  private Vector parados;

  private JSiscoma pai;

  private JButton btContinuar;

  private JButton btParar;

  private JTable tbAtivos;

  private JTable tbParados;

  private JTable tbConcluidos;

  private DefaultTableModel tmAtivos;
  
  private DefaultTableModel tmParados;

  private DefaultTableModel tmConcluidos;
  

  private java.util.Timer timer;

  private static final String [ ] COLNOMES = 
  {"Nome", "Servidor", "Bytes Transferidos", "Taxa (kB/s)"};
  
  public JDownload (JSiscoma pai) {

    setLayout(new GridLayout(3, 1));
    setPreferredSize(new Dimension(600, 600));
    this.pai = pai;
    this.ativos = new Vector( );
    this.parados = new Vector( );
    
    this.timer = new java.util.Timer( );
    timer.schedule(new Atualizar( ), 1000);

    /* */ 
    
    this.tmAtivos = new DefaultTableModel( );
    tmAtivos.setColumnIdentifiers(COLNOMES);
    this.tbAtivos = new JTable(tmAtivos);    

       
    JPanel p3 = new JPanel(new FlowLayout(FlowLayout.CENTER, 20, 5));    
    this.btParar = new JButton("Parar o download");
    btParar.addActionListener(this);
    p3.add(btParar);

    JPanel p1 = new JPanel(new BorderLayout( ));
    p1.setBorder(BorderFactory.createTitledBorder("Downloads em andamento"));

    p1.add("Center", new JScrollPane(tbAtivos));
    p1.add("South", p3);   
    
    
    /* */ 
    
    this.tmParados = new DefaultTableModel( );
    tmParados.setColumnIdentifiers(COLNOMES);
    this.tbParados = new JTable(tmParados);    
    
    JPanel p4 = new JPanel(new FlowLayout(FlowLayout.CENTER, 20, 5));    
    this.btContinuar = new JButton("Continuar o download");
    btContinuar.addActionListener(this);
    p4.add(btContinuar);

    JPanel p2 = new JPanel(new BorderLayout( ));
    p2.setBorder(BorderFactory.createTitledBorder("Downloads parados"));

    
    p2.add("Center", new JScrollPane(tbParados));
    p2.add("South", p4);   



    /* */ 
    
    this.tmConcluidos = new DefaultTableModel( );
    tmConcluidos.setColumnIdentifiers(COLNOMES);
    this.tbConcluidos = new JTable(tmConcluidos);    
        

    JPanel p6 = new JPanel(new BorderLayout( ));
    p6.setBorder(BorderFactory.createTitledBorder("Downloads concludos" ));

    
    p6.add("Center", new JScrollPane(tbConcluidos));    



    add(p1);
    add(p2);

    add(p6);
   
  }

  public boolean jaIniciou (ArquivoRemoto ar) {

    for (int i = 0; i < ativos.size( ); i++) {	
      if (ar.arquivoIgual(((GerenciadorDeTransferencia) 
			   ativos.elementAt(i)).arquivoRemoto( )))
	return true;
    }        
    return false;
    
  }


  public void novoDownload (GerenciadorDeTransferencia gt) {
        
    ArquivoRemoto ar = (ArquivoRemoto) gt.arquivoRemoto( );
    Vector info = new Vector( );
    info.addElement(ar.nome( ));
    info.addElement(ar.nomeDoServidor( ));
    info.addElement(Integer.toString(gt.bytesTransferidos( )));
    info.addElement(Double.toString(gt.velocidadeMedia( )));
    tmAtivos.addRow(info);      
    ativos.addElement(gt);
    
  }

  public void troqueServidor (ArquivoRemoto ar) {

    for (int i = 0; i < ativos.size( ); i++) {	
      GerenciadorDeTransferencia gt = (GerenciadorDeTransferencia) 
	ativos.elementAt(i);
      if (ar.arquivoIgual(gt.arquivoRemoto( ))) {
	try {
	  gt.trocaServidor(ar);
	  tmAtivos.setValueAt(ar.nome( ), i, 0);
	  tmAtivos.setValueAt(ar.nomeDoServidor( ), i, 1);
	}
	catch (Exception e) {}
	return;
      }	
    }        

  }  
  
  public void actionPerformed (ActionEvent e) {
    
    Object obj = e.getSource( );
    if (obj instanceof JButton) {
      JButton b = (JButton) obj;
      if (b == btParar) {	
	int i = tbAtivos.getSelectedRow( );
	if (i != -1) {	  
	  GerenciadorDeTransferencia gt = 
	    (GerenciadorDeTransferencia) ativos.elementAt(i); 
	  gt.interrompe( );
	  tmAtivos.removeRow(i);
	  ativos.removeElementAt(i);	  
	  ArquivoRemoto ar = (ArquivoRemoto) gt.arquivoRemoto( );
	  Vector info = new Vector( );
	  info.addElement(ar.nome( ));
	  info.addElement(ar.nomeDoServidor( ));
	  info.addElement(Integer.toString(gt.bytesTransferidos( )));
	  info.addElement(JSiscoma.formato.format(gt.velocidadeMedia( )));
	  parados.addElement(gt);	  
	  tmParados.addRow(info);
	}	
      }
      else if (b == btContinuar) {		
	int i = tbParados.getSelectedRow( );
	if (i != -1) {	  
	  GerenciadorDeTransferencia gt = 
	    (GerenciadorDeTransferencia) parados.elementAt(i); 
	  gt.continua( );
	  tmParados.removeRow(i);
	  parados.removeElementAt(i);
	  ativos.addElement(gt);
	  
	  ArquivoRemoto ar = (ArquivoRemoto) gt.arquivoRemoto( ) ;
	  Vector info = new Vector( );
	  info.addElement(ar.nome( ));
	  info.addElement(ar.nomeDoServidor( ));
	  info.addElement(Integer.toString(gt.bytesTransferidos( )));
	  info.addElement(JSiscoma.formato.format(gt.velocidadeMedia( )));	  
	  tmAtivos.addRow(info);
	}	
      }
    } 
    
    atualize();
  }  
    
  public void atualize ( ) {
    
    for (int i = 0; i < ativos.size( ); i++) {      
      GerenciadorDeTransferencia gt = 
	(GerenciadorDeTransferencia) ativos.elementAt(i);
      if (!gt.terminou( )) {
	tmAtivos.setValueAt(Integer.toString(gt.bytesTransferidos( )), i, 2);
	tmAtivos.setValueAt(Double.toString(gt.velocidadeMedia( )), i, 3);
      }
      else {
	

	tmAtivos.removeRow(i);
	ativos.removeElementAt(i);	  
	ArquivoRemoto ar = (ArquivoRemoto) gt.arquivoRemoto( );
	Vector info = new Vector( );
	info.addElement(ar.nome( ));
	info.addElement(ar.nomeDoServidor( ));
	info.addElement(Integer.toString(gt.bytesTransferidos( )));
	info.addElement(JSiscoma.formato.format(gt.velocidadeMedia( )));	
	tmConcluidos.addRow(info);


	
      }
    }
    
    timer.schedule(new Atualizar( ), 1000);

  }
  

  class Atualizar extends TimerTask {

    public void run ( ) {      
      
      atualize( );      
      
    }
    
  }



}
