/* MAC 440/5759 - Sistemas de Objetos Distribudos  */
/* IME-USP - 1o.sem/2002 - Prof. Fabio Kon          */
/*                                                  */
/* Projeto Final: Siscoma                           */
/*                                                  */
/* Emerson Luiz Navarro  - emr@linux.ime.usp.br     */
/* Leo Kazuhiro Ueda     -  lku@ime.usp.br          */
/* Pratip Roy Chowdhury  - roy@linux.ime.usp.br     */
/* Ricardo Hideo Sahara  - hideo@linux.ime.usp.br   */
/*                                                  */


/* JResultadoDaBusca.java */

import siscoma.orb.*;
import siscoma.orb.ServentePackage.*;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;
import javax.swing.table.*;
import java.util.*;

public class JResultadoDaBusca extends JPanel {

  private String id;

  private JTable tabela;

  private DefaultTableModel dm;

  private Vector arquivosRemotos;

  private JBusca jbusca;
  
  private static final Vector COLNOMES = nomeDasColunas( );
  
  public JResultadoDaBusca (JBusca jbusca, String id) {

    this.id = id;
    this.jbusca = jbusca;    
    this.arquivosRemotos = new Vector( );    
    this.dm = new DefaultTableModel(new Vector( ), COLNOMES);
    this.tabela = new JTable(dm);
    tabela.addMouseListener(new MouseAdapter( ) {
	public void mouseClicked(MouseEvent e) {	  	  	  
	  baixarArquivo(tabela.getSelectedRow( ));
	}
      });        
    add(new JScrollPane(tabela));
    
  } 

  public String id ( ) {

    return id;

  }

  private static Vector nomeDasColunas ( ) {

    String nomes[ ] = {"Nome do Arquivo", "Nome do Servidor", "Tamanho (Mb)"}; 
    Vector v = new Vector( );
    for (int i = 0; i < nomes.length; i++) 
      v.addElement(nomes[i]);
    return v;
    
  }
  
  private void baixarArquivo (int i) {
    
    if (i != -1) {
      jbusca.baixarArquivo((ArquivoRemoto) arquivosRemotos.elementAt(i));          
    }
    
  }

  public void adicionar (Collection c) {
    
    Iterator it = c.iterator( );
    while (it.hasNext( )) {
      ArquivoRemoto ar = (ArquivoRemoto) it.next( );      
      Vector linha = new Vector( );
      linha.addElement(ar.nome( ));
      linha.addElement(ar.nomeDoServidor( ));
      linha.addElement(Integer.toString(ar.tamanho( )));
      dm.addRow(linha);
      arquivosRemotos.addElement(ar);
      
    }

  }

}
