/* MAC 440/5759 - Sistemas de Objetos Distribudos  */
/* IME-USP - 1o.sem/2002 - Prof. Fabio Kon          */
/*                                                  */
/* Projeto Final: Siscoma                           */
/*                                                  */
/* Emerson Luiz Navarro  - emr@linux.ime.usp.br     */
/* Leo Kazuhiro Ueda     -  lku@ime.usp.br          */
/* Pratip Roy Chowdhury  - roy@linux.ime.usp.br     */
/* Ricardo Hideo Sahara  - hideo@linux.ime.usp.br   */
/*                                                  */


/* JSiscoma.java */

import siscoma.orb.Servente;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.*;
import java.text.DecimalFormat;

public class JSiscoma extends JFrame implements IGui {

  private ServenteImpl servente;
  private JTabbedPane tab;
  private JBusca jbusca;
  private JDownload jdownload;
  private JUpload jupload;
  private JSiscomaNet jsiscomanet;
  private JConfig jconfig;
  
  public static DecimalFormat formato = new DecimalFormat("0.00");
  

  public JSiscoma (ServenteImpl servente, String s) {

    super("Siscoma - " + s);   
    setVisible(true);
    setSize(new Dimension(700, 500));    
    this.servente = servente;
    this.tab = new JTabbedPane( );
    tab.setBackground(Color.orange);
    this.jsiscomanet = new JSiscomaNet(this);
    this.jbusca = new JBusca(this);
    this.jdownload = new JDownload(this);
    this.jupload = new JUpload(this);
    this.jconfig = new JConfig(this);
    this.tab.addTab("SiscomaNet", jsiscomanet);
    this.tab.addTab("Busca", jbusca);
    this.tab.addTab("Download", jdownload);    
    this.tab.addTab("Upload", jupload);    
    this.tab.addTab("Config", jconfig);    
    this.getContentPane( ).add(tab);       
    pack( );
    
    repaint( );            

  }

  public String buscarArquivo (String padrao) {

    return servente.gui_busca_arquivos(padrao);
    
  }

  public void resposta_da_busca(Collection c) {
    
    jbusca.resultadoDaBusca(c);

  }

  public void baixarArquivo (ArquivoRemoto ar) {

    tab.setSelectedComponent(jdownload);
    if (jdownload.jaIniciou(ar)) 
      jdownload.troqueServidor(ar);
    else
      jdownload.novoDownload(servente.gui_pega_arquivo(ar));

  }
  
  public void novo_amigo (String nome, Servente s) {

    jsiscomanet.novoAmigo(nome, s);

  }

  public void caiu_amigo (String nome, Servente s) {

    jsiscomanet.caiuAmigo(nome, s);

  }

  public void enviou(String arq, int pos, int numBytes) {

    jupload.novoUpload(arq, pos, numBytes);
    
  }

  public Collection  serventesDoSN( ) {

    return servente.gui_serventes_do_sn();

  }

  public String nomeDoServente (Servente s) {
    
    return servente.gui_nome_servente(s);

  }

  public void conectar (Servente s) {

    servente.gui_ping(s);

  }

  public void desconectou(String nome, Servente s) {

    jsiscomanet.caiuAmigo(nome, s);

    
  }
  
  

}
