/* MAC 440/5759 - Sistemas de Objetos Distribudos  */
/* IME-USP - 1o.sem/2002 - Prof. Fabio Kon          */
/*                                                  */
/* Projeto Final: Siscoma                           */
/*                                                  */
/* Emerson Luiz Navarro  - emr@linux.ime.usp.br     */
/* Leo Kazuhiro Ueda     -  lku@ime.usp.br          */
/* Pratip Roy Chowdhury  - roy@linux.ime.usp.br     */
/* Ricardo Hideo Sahara  - hideo@linux.ime.usp.br   */
/*                                                  */


/* JSiscomaNet.java */

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.table.*;
import siscoma.orb.Servente;

public class JSiscomaNet extends JPanel implements ActionListener {

  private JSiscoma pai;

  private DefaultTableModel tmAmigos;

  private JTable tbAmigos;

  private JButton btDesconectar;

  private JList ltSn;

  private DefaultListModel lmSn;

  private Vector amigos;

  private JButton btAtualizar;

  private JButton btConectar;

  private Vector sn;
  
  private static final String [ ] COLNOMES = {"Nome do Servidor"};
  
  public JSiscomaNet (JSiscoma pai) {
    
    setLayout(new GridLayout(2, 1));
    setPreferredSize(new Dimension(600, 600));
    this.pai = pai;    
    this.amigos = new Vector( );
    this.tmAmigos = new DefaultTableModel( );    
    this.sn = new Vector( );
    tmAmigos.setColumnIdentifiers(COLNOMES);
    this.tbAmigos = new JTable(tmAmigos);        
    JPanel p1 = new JPanel(new BorderLayout( ));
    p1.setBorder(BorderFactory.createTitledBorder("Meus amigos"));
    p1.add("Center", new JScrollPane(tbAmigos));    
    add(p1);
    
    
    JPanel p3 = new JPanel(new BorderLayout( ));        
    add(p3);
    p3.setBorder(BorderFactory.createTitledBorder
		 ("Serventes do servio de nomes"));    
    
    this.lmSn = new DefaultListModel();
    this.ltSn = new JList(lmSn);
    JScrollPane listScrollPane = new JScrollPane(ltSn);
    listScrollPane.setPreferredSize(new Dimension(300, 200));   
    p3.add("Center", listScrollPane);    
    
    
    JPanel p4 = new JPanel(new FlowLayout(FlowLayout.CENTER, 20, 5));            
    p3.add("South", p4);

    
    this.btAtualizar = new JButton("Atualizar");
    btAtualizar.addActionListener(this);
    p4.add(btAtualizar);       


    this.btConectar =  new JButton("Conectar");
    btConectar.addActionListener(this);
    p4.add(btConectar);
    
    
    atualizarSN( ); 

  }


  private void atualizarSN ( ) {

    Collection c = pai.serventesDoSN( );
    lmSn.removeAllElements( );
    sn.removeAllElements( );
    Iterator it = c.iterator( );
    while (it.hasNext( )) {
      Servente s = (Servente) it.next( );
      String nome = pai.nomeDoServente(s);
      if (nome != null) {
	sn.addElement(s);
	lmSn.addElement(nome);
      }
    }

  }

  private Vector nomeDasColunas ( ) {
    
    Vector v = new Vector( );
    for (int i = 0; i < COLNOMES.length; i++) 
      v.addElement(COLNOMES[i]);
    return v;

  }
  
  public void novoAmigo (String nome, Servente s) {

    
    amigos.addElement(new Amigo(nome, s));
    Vector info = new Vector( );
    info.add(nome);
    tmAmigos.addRow(info);
    

  }

  public void caiuAmigo (String nome, Servente s) {
    
    Amigo a = new Amigo(nome, s);
    int i = amigos.indexOf(a);
    if (i != -1) {      
      amigos.removeElement(a);
      tmAmigos.removeRow(i);
    }

  }

  public void actionPerformed (ActionEvent e) {
    
    Object obj = e.getSource( );
    if (obj instanceof JButton) {
      JButton b = (JButton) obj;
      if (b == btDesconectar) {
	
      }	
      else if (b == btAtualizar) {
	atualizarSN ( );
      }
      else if (b == btConectar) {
	int i = ltSn.getSelectedIndex();
	if (i != -1) {
	  Servente s = (Servente) sn.elementAt(i);
	  pai.conectar(s);
	}
	
      }
	
    }      
  }

  class Amigo {

    String nome;

    Servente servente;

    Amigo (String nome, Servente servente) {

      this.nome = nome;
      this.servente = servente;

    } 
    
    public boolean equals (Object outro) {

      Amigo a = (Amigo) outro;
      return servente.equals(a.servente);

    } 
    
  }  
  
}    

