/* MAC 440/5759 - Sistemas de Objetos Distribudos  */
/* IME-USP - 1o.sem/2002 - Prof. Fabio Kon          */
/*                                                  */
/* Projeto Final: Siscoma                           */
/*                                                  */
/* Emerson Luiz Navarro  - emr@linux.ime.usp.br     */
/* Leo Kazuhiro Ueda     -  lku@ime.usp.br          */
/* Pratip Roy Chowdhury  - roy@linux.ime.usp.br     */
/* Ricardo Hideo Sahara  - hideo@linux.ime.usp.br   */
/*                                                  */


/* ServenteImpl.java */

import java.util.Timer;
import java.util.TimerTask;
import siscoma.orb.*;
import siscoma.orb.ServentePackage.*;
import java.util.*;
import java.io.*;
import org.omg.CosNaming.*;

/**
 * Esta classe....
 * @author Emerson Luiz Navarro Tozette - emr@linux.ime.usp.br
 * @author Leo Kazuhiro Ueda            - lku@ime.usp.br
 * @author Pratip Roy Chowdhury         - roy@linux.ime.usp.br
 * @author Ricardo Hideo Sahara         - hideo@linux.ime.usp.br
 * @version 0.0 2002/06/29
 */ 

public class ServenteImpl extends ServentePOA {

  private IGui GUI;

  private NamingContextExt NC;

  private Map Amigos;
  private Set _caidos;

  private CaixaDeMensagens mensagens;     // tabela de mensagens atendidas
  private CaixaDeCoisas mensagensDeBusca; // tabela de mensagens de busca atendidas
  private CaixaDeCoisas readers;          // 
  
  private int IdMsg; // para ajudar na gerao dos ids de msgs

  private String Nome;

  /**
   *
   */ 

  private String ior;

  /**
   *
   */ 

  private Timer timer;

  /**
   *
   */ 


  public void p (String s) {

    System.out.println(Nome + ": " + s);

  }

  /**
   *
   */ 
  
  /********************************************************************************/

  public ServenteImpl (org.omg.CORBA.ORB orb , org.omg.PortableServer.POA poa, 
		       Collection amigos, String nome,
		       String arqIor, String nomeSN) {
    
    this.IdMsg = 0;
    this.Amigos = new Hashtable( );    
    this._caidos = new HashSet();
    this.Nome = nome;
    this.mensagens = new CaixaDeMensagens( );
    this.mensagensDeBusca = new CaixaDeCoisas( );
    this.readers = new CaixaDeCoisas( );

    try {
      org.omg.CORBA.Object obj = poa.servant_to_reference(this);
      this.ior = orb.object_to_string(obj);

      GUI = new JSiscoma(this, Nome);

      if (arqIor != null) {
	System.out.println("Imprimindo a IOR de '" + Nome + "' no arquivo " +
			   arqIor + "...");
	PrintWriter ps = new PrintWriter
	  ( new FileOutputStream( new File( arqIor )));
	ps.println( ior );
	ps.close();
      }
      if (nomeSN != null) {
	System.out.println("Registrando '" +
			   nomeSN + "' no servio de nomes... " +
			   "(subcontexto 'SiscomaNet')");

	org.omg.CosNaming.NamingContextExt ncR = 
	  org.omg.CosNaming.NamingContextExtHelper.narrow
	  (orb.resolve_initial_references("NameService"));
	
	try {
	  NC = NamingContextExtHelper.narrow( 
	    ncR.resolve( ncR.to_name("SiscomaNet") ));
	  //NC = ServenteHelper.narrow(NC.resolve(bh.value.binding_name));
	}
	catch (Exception e) {
	  NC = NamingContextExtHelper.narrow( 
	    ncR.bind_new_context( ncR.to_name("SiscomaNet") ));
	}
	
	NC.bind( NC.to_name(nomeSN), obj );
      }

    }
    catch (Exception e) {}


    Iterator it = amigos.iterator( );
    String mid = geraIdMsg( );
    while (it.hasNext( )) {       
      Servente s = (Servente) it.next( );            
      s.ping(this._this( ), this._this( ), mid, Siscoma.TDV, 0);
    }

    timer = new Timer( );
    timer.schedule(new Atualizar( ), 1000);

  }

  /** Mtodos auxiliares **********************************************************/

  public Map amigos() { return Amigos; }

  private void removeCaidos() {
    Iterator it = _caidos.iterator();
    while (it.hasNext()) {
      Servente s = (Servente)it.next();
      GUI.caiu_amigo((String) Amigos.get(s), s);
      Amigos.remove(s);
    }
    _caidos.clear();
  }
  
  /**
   * Gera um identificador, supostamente nico.
   * Usado para enviar mensagens remotas.
   */
  private String geraIdMsg ( ) {
    // return ior + Integer.toString(IdMsg++);
    return this._this().toString() + "-" +
      System.currentTimeMillis() +  "-" + Integer.toString(IdMsg++);    
  }

  /**
   * Verifica se este servente aceita ser amigo de mais algum.
   */
  private boolean aceitoConexao ( ) {
    return true;
  }

  public void atualize ( ) {    
    mensagens.decTdv( );
    timer.schedule(new Atualizar( ), 1000);
  }
  

  class Atualizar extends TimerTask {
    public void run ( ) {
      atualize( );      
    }
  }

  /** Mtodos da IDL (Interface Servente) *****************************************/

  /**
   * origem torna-se amigo deste servente. Se tdv > 0, a mensagem idMsg 
   * repassada para todos os amigos deste servente com o tempo de vida diminuido
   * de uma unidade e o tempo de vida reverso aumentado de uma unidade.
   * O remetente serve s para no enviar a mensagem idMsg de novo para ele.
   * @param origem Servente de onde originou o ping.
   * @param remetente Servente que repassou a mensagem.
   * @param idMsg identificador nico da mensagem. 
   * @param tdv tempo de vida da mensagem.
   * @param tdvr tempo de vida reverso da mensagem.
   */ 
  
  public void ping (Servente origem, Servente remetente, String idMsg, int tdv, 
		    int tdvr) {
    
    p("Ping: Recebendo mensagem id = " + idMsg);
    /* Verifico se j recebi a mensagem. */ 
    if (mensagens.recebi(idMsg)) {    
      p("Ping: Recusei mensagem id = " + idMsg);
      return;        
    }
    /* Guardo a mensagem recebida. */ 
    mensagens.guarde(idMsg);
    p("Ping: Aceitei mensagem id = " + idMsg);
    /* Repasso a mensagem para os amigos deste servente caso o tempo de vida
       da mensagem  maior do que zero. */
    if (tdv > 0) {
      Iterator it = Amigos.keySet( ).iterator( );
      while (it.hasNext( )) {
	Servente s = (Servente) it.next( );	
	try {
	  if (!s.equals(remetente) && !s.equals(origem)) {
	    p("Ping: Pingando para " + s.nome_servente( ));	  
	    s.ping(origem, this._this( ), idMsg, tdv - 1, tdvr + 1);	  
	  }	  	
	}
	catch (org.omg.CORBA.TRANSIENT t) { 
	  System.out.println(s + " caiu.");
	  _caidos.add(s);
	}
      }
      removeCaidos();
    }        
    /* Posso aceitar ou no ser amigo do servente que originou a mensagem. */ 
    if (aceitoConexao( )) {      
      String nome = origem.nome_servente( );
      if (!Amigos.containsKey(origem)) {
	p("Meu novo amigo: " + nome);
	Amigos.put(origem, nome);
	GUI.novo_amigo(nome, origem);
      }
      p("Pongando para " + nome);
      origem.pong(this._this( ));
    } 
    
  }
  
  /**
   * servidor se tornar amigo deste servente.  
   * @param servidor  o servente que chamou este mtodo.
   */ 
  
  public void pong (Servente servidor) {
    
    p("Recebendo um pong de " + servidor.nome_servente( ));
    if (!Amigos.containsKey(servidor)) {
      String nome = servidor.nome_servente( );
      p("Aceitando um pong de " + servidor.nome_servente( ));
      Amigos.put(servidor, nome);
      GUI.novo_amigo(nome, servidor);
    }

  }
  
  /**     
   * Se este servente tiver o arquivo procurado, ele responde chamando
   * o mtodo respota_da_busca do cliente.
   * A busca  repassada para todos os amigos deste servente com o tempo de vida 
   * diminuido de uma unidade e o tempo de vida reverso aumentado de uma unidade.   
   * @param cliente servente que requisitou a busca. 
   * @param idMsg identificador nico da mensagem. 
   * @param tdv tempo de vida da mensagem.
   * @param tdvr tempo de vida reverso da mensagem.
   * @param padrao nome do arquivo procurado.
   */ 
  
  public void busca_arquivos(Servente cliente, String idMsg, int tdv, int tdvr, 
			     String padrao) {
    
    if (mensagens.recebi(idMsg))
      return;

    // guardo a mensagem recebida:
    mensagens.guarde(idMsg);
    if (mensagens.recebi(idMsg))
      System.out.println("******"+ idMsg);

    /* Busca */

    File f = new File(Siscoma.DIRCOMP);
    File arquivos[ ] = f.listFiles( );
    ArrayList achados = new ArrayList( );
    // !!!!!!!!!!!!!! Percorrer os subdiretorios 
    // !!!!!!!!!!!!!! Busca por expressao regular 
    for (int i = 0; i < arquivos.length; i++) {      
      if (!arquivos[i].isDirectory( )) {
	if (arquivos[i].getName( ).equalsIgnoreCase(padrao)) 
	  achados.add(new DescricaoDeArquivo(arquivos[i].getName( ), 
					     (int)arquivos[i].length( ), 0));	
      }
    }
    if (achados.size( ) > 0) {
      DescricaoDeArquivo v[ ] = new DescricaoDeArquivo[achados.size( )];
      for (int i = 0; i < achados.size( ); i++) 
	v[i] = (DescricaoDeArquivo) achados.get(i);
      Servente s = this._this();
      try {
	new Thread( ).sleep((int) (Math.random( ) * 2000));
      }
      catch (Exception e) { }
      cliente.resposta_da_busca(new Resultado(s, v), idMsg);
      p("Respondendo: " + idMsg);
    }
    else p("Nao foi achado o arquivo " + padrao);


    /* Repassa */

    if (tdv > 0) {
      Iterator it = Amigos.keySet( ).iterator( );
      mensagensDeBusca.guarde(idMsg, cliente);
      while (it.hasNext( )) {
	Servente s = (Servente) it.next( );	
	if (!s.equals(cliente)) {	  
	  s.busca_arquivos(this._this(), idMsg, tdv - 1, tdvr + 1, padrao);
	}
      }
    }
    
  }

  /**
   *  chamado quando queremos devolver a resposta da busca.
   * Caso no seja este servente que requisitou a busca <code>id_da_mensagem
   * </code>, a resposta  repassada para quem chamou o mtodo 
   * <code>busca_arquivos</code> deste servente com o identificador da 
   * mensagem igual a  <code>id_da_mensagem</code>.
   * @param resultado resultado da busca.
   * @param id_da_mensagem identificador nico da mensagem da busca.
   */ 

  public void resposta_da_busca(Resultado resultado, String id_da_mensagem) {
    
    p("Recebi um resultado.");

    Servente origem = (Servente)mensagensDeBusca.pega(id_da_mensagem);
    if (origem == null) return;

    p("1.");

    if (origem.equals(this._this())) { //  pra mim mesmo...
      Collection arqs = new ArrayList();
    p("2");
      DescricaoDeArquivo arquivos[ ] = resultado.arquivos;
      System.out.println("Resultado da busca:");
      for (int i = 0; i < arquivos.length; i++) {
	ArquivoRemoto ar = new ArquivoRemoto(arquivos[i].nome, arquivos[i].tamanho,
					     arquivos[i].hash, resultado.servidor,
					     id_da_mensagem);
	arqs.add(ar);
	System.out.println(arquivos[i].nome);
      }
      GUI.resposta_da_busca(arqs);
    }
    else { // no  pra mim, repassa pra quem chamou...
      origem.resposta_da_busca(resultado, id_da_mensagem);
    }

  }

  /**
   * Chame este mtodo para receber <code>n</code> bytes a partir de 
   * <code>deslocamento</code> bytes do incio do arquivo cujo nome  
   * <code>nome_do_arquivo</code>.
   * @param nome_do_arquivo nome do arquivo.
   * @param deslocamento deslocamento a partir do incio do arquivo.
   * @param n nmero de bytes a ser devolvidos.
   */ 
  
  public int[] pega_arquivo(String nome_do_arquivo, int deslocamento, int n) {
    
    System.out.println("pega_arquivo " + nome_do_arquivo + " " + deslocamento);
    try {
      BufferedReader buffer = (BufferedReader)readers.pega(nome_do_arquivo);

      if (buffer == null) {
	File f = new File(Siscoma.DIRCOMP + "/" + nome_do_arquivo);
	buffer = new BufferedReader(new FileReader(f));	
	buffer.mark((int) f.length( ));
	readers.guarde(nome_do_arquivo, buffer);
      } 
      char c[ ] = new char[n];
      buffer.reset();
      buffer.skip(deslocamento);
      int nlidos = buffer.read(c, 0, n);
      int a[ ] = new int[nlidos];
      for (int i = 0; i < a.length; i++) 
	a[i] = (int) c[i];
      
      GUI.enviou(nome_do_arquivo, deslocamento, n);
      return a;
    }
    catch (IOException e) {
      p("IOE");
    }
   
    return null;
    
  }
  
  public void cutuca() {}
  
  public String nome_servente ( ) { 
    
    return Nome; 

  }

  public void desconecta (Servente s) {
    
    String nome = (String)Amigos.get(s);
    if (nome == null) return;
    GUI.desconectou(nome, s);
    
  }

  /** Mtodos oferecidos  GUI ****************************************************/


  /**
   * Oferece  GUI a operao de busca por arquivos, segundo
   * um padro de nomes de arquivos.
   * As respostas, como na arquitetura do Servente, vm atravs
   * de chamadas ao mtodo {@link IGui#resposta_da_busca(Collection)}.
   * <p>
   * Vale lembrar tambm que o padro pode ser interpretado de qualquer
   * maneira pelo servidor que recebe a consulta.
   * </p)
   *
   * @param padrao o padro de nome de arquivo que ser usado na busca
   * @return o ID da mensagem que originar a busca.
   */
  public String gui_busca_arquivos(String padrao) {
    Iterator it = Amigos.keySet( ).iterator( );
    String mid = geraIdMsg();
    while (it.hasNext( )) {
      Servente s = (Servente) it.next( );	
      try {
	mensagensDeBusca.guarde(mid, this._this());
	s.busca_arquivos(this._this(), mid , Siscoma.TDV, 0, padrao);
      }
      catch (org.omg.CORBA.TRANSIENT t) { 
	System.out.println(s + " caiu.");
	_caidos.add(s);
      }
    }  
    removeCaidos();
    return mid;
  }

  /**
   * Oferece  GUI a operao de recebimento de arquivos, segundo
   * um padro de nomes de arquivos.
   * A transferncia do arquivo  iniciada com essa mensagem,
   * e o acesso a informaes sobre ela  representado por um objeto
   * {@link GerenciadorDeTransferencia}, que  devolvida no retorno.
   *
   * @param a estrutura que representa um arquivo remoto
   * @return um objeto para gerenciar e monitorar o recebimento.
   */
  public GerenciadorDeTransferencia  gui_pega_arquivo(ArquivoRemoto ar) {    
    return new GerenciadorDeTransferencia(ar, Siscoma.TAMBLOCO);
  }

  /** 
   * Fornece os "Amigos# deste <code>Servente</code>.
   *
   * @return uma <code>Collection</code>
   *         de referncias {@link Servente}
   */
  public Collection gui_amigos() {

    return Amigos.values();

  }

  /**
   * Lista os serventes que esto no servio de nomes.
   *
   * @return os serventes registrados no servio de nomes
   */
  public Collection gui_serventes_do_sn() {

    if (NC == null) return new ArrayList();

    Collection res = new HashSet();

    BindingListHolder blh = new BindingListHolder();
    BindingIteratorHolder bih = new BindingIteratorHolder();

    NC.list(0, blh, bih);
    System.out.println("lista---- ");

    BindingIterator it = bih.value;
    BindingHolder bh = new BindingHolder();
    while (it.next_one(bh)) {
      try {
	Servente s = ServenteHelper.narrow(NC.resolve(bh.value.binding_name));
	if (!s.equals(this._this()))
	  res.add(s);      
	System.out.println("lista sn " + s.nome_servente());
      } catch (Exception e ) {}

    }

    return res;
  }

  /**
   * Envia um {@link ping(Servente, Servente, String, int, int}
   * para um <code>Servente</code> dado.
   *
   * @param s o <code>Servente</code>
   */
  public void gui_ping(Servente s) {
    String mid = geraIdMsg( );
    try {
      s.ping(this._this( ), this._this( ), mid, Siscoma.TDV, 0);
    }
    catch (org.omg.CORBA.TRANSIENT t) { 
      System.out.println(s + " caiu.");
    }     
  }

  /**
   * Fornece a GUI um meio para obter o nome de um servente.
   * Este mtodo pode recorrer  uma tabela de nomes local
   * ou a uma chamada remota para o servente
   *
   * @return o nome do Servente, ou <code>null</code>
   *         se o mtodo no conseguiu descobrir o nome
   */
  public String gui_nome_servente(Servente s) {
    String res = (String)Amigos.get(s);
    if (res == null) {
      try {
	res = s.nome_servente();
      }
      catch (org.omg.CORBA.TRANSIENT t) { 
	  System.out.println(s + " caiu.");
      }    
    }
    return res;
  }

  /**
   * Fornece a GUI o tempo de resposta (ping) de um servente.
   *
   * @param s o servente
   * @return tempo de resposta em milissegundos, ou -1 se
   *         o servente caiu
   */
  public long gui_tempo_de_resposta(Servente s) {
    long res = -1;
    try {
      long ti = System.currentTimeMillis();
      s.cutuca();
      res = System.currentTimeMillis() - ti;
    }
    catch (org.omg.CORBA.TRANSIENT t) { 
      System.out.println(s + " caiu.");
    }    
    return res;
  }

  
  /**
   * Fornece  GUI o tempo de resposta (ping) de um servente.
   *
   * @param s o servente
   * @return tempo de resposta em milissegundos, ou -1 se
   *         o servente caiu
   */
  public void gui_desconecta() {
    Iterator it = Amigos.keySet( ).iterator( );
    while (it.hasNext( )) {
      Servente s = (Servente) it.next( );
      try {
	if (!s.equals(this._this())) {
	  s.desconecta(this._this());
	}	  	
      }
      catch (org.omg.CORBA.TRANSIENT t) { 
	System.out.println(s + " caiu.");
	_caidos.add(s);
      }
    }
  }

}

/**********************************************************************************/

/**
 * Classe interna, no interessa muito...
 * O mtodo <code>acao</code>  executado
 * sempre que uma 'coisa'  removida
 * de uma <code>CaixaDeCoisas</code>.
 * 
 * @see {@link CDDestrutor}
 * @see {@link CaixaDeCoisas}
 */
class CDCDReader implements CDCDestrutor {
  private static CDCDReader Instancia;

  private CDCDReader() {
    if (Instancia != null)
      throw new Error("S pode haver um!");
  }

  public void acao(Object coisa) {
    try {
      ((Reader)coisa).close();
    } catch (IOException ioe) { }
  }

  public static CDCDReader instancia() {
    if (Instancia == null)
      Instancia = new CDCDReader();
    return Instancia;
  }
}
